;;----------------------------------------
;; Expertni system, ehm. spis gameska :-)
;; Jan Matuska, matuska@kn.vutbr.cz
;; VUT-ID: 14689
;; Group:  5O/48
;;----------------------------------------


;; vypise pozadavek na zadani prikazu
;; vrati pouze hodnoty obsazene v $?allowed-values
;; opakuje pozadavek do zadani povolene hodnoty
(deffunction ask-question (?question $?allowed-values)
   (printout t ?question)
   (bind ?answer (read))
   (if (lexemep ?answer)
       then (bind ?answer (lowcase ?answer))
   )
   (while (not (member ?answer ?allowed-values)) do
      (printout t ?question)
      (bind ?answer (read))
      (if (lexemep ?answer)
          then (bind ?answer (lowcase ?answer))
      )
   )
   ?answer
)


;; vypise prikazy a vrati pismenko s akci
(deffunction show-get-commands ()
  (printout t crlf)
  (printout t "Prikazy: [s]ever, [j]ih, [z]apad, [v]vychod, vz[i]t, [k]onec")
  (printout t crlf crlf)
  (bind ?response (ask-question "Zadej povel: " s j z v i k))
  (switch ?response
    (case s then  (printout t "Jdes na sever") )
    (case j then  (printout t "Jdes na jih")  )
    (case z then  (printout t "Jdes na zapad") )
    (case v then  (printout t "Jdes na vychod") )
    (case i then  (printout t "Beres") )
    (case k then  (printout t "Adios amigo...") )
    (default none)
  )  
  (printout t crlf)
  (printout t "-------------------------------------------------------------------------------------")  
  (printout t crlf crlf)
  ?response
)

;; vypise zes narazil drzkou do zdi
(deffunction drzkoryje ()
   (printout t "Tve odhodlani jit timto smerem zpusobilo, zes drzkou narazil do zdi.. a to boli :-)")
   (printout t crlf crlf)
)

;; vypise ze tu nic neni
(deffunction tu-nic-neni ()
   (printout t "Kupodivu zde nic neni :-(")
   (printout t crlf crlf)
)


;; The Story begins here....
(defrule system-banner ""
  (declare (salience 10))
  =>
  (printout t crlf crlf)
  (printout t "*************************************************************************************")
  (printout t crlf)
  (printout t "        Expertni system neni expertnim nazvan proto, ze resi experni problemy,")
  (printout t crlf)
  (printout t "        ale proto, ze clovek musi byt expert, aby v tom neco naprogramoval :-)")
  (printout t crlf)
  (printout t "*************************************************************************************")
  (printout t crlf crlf)
  (assert (room 1) )
)

;; --- Pocitacova ucebna 715 ----
(defrule room_1_text ""
  (not (mam plny-brisko))
  (room 1)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Nachazis se v pocitacove ucebne 715, kolem sebe vidis nekolik svych spoluzaku, kteri")
  (printout t crlf)
  (printout t "koukaji do svych obrazovek a nevnimaji deni kolem sebe. Nekdo sledujue novinky na") 
  (printout t crlf)
  (printout t "youtube.com, nekdo zalohuje originalni blueraye, nekdo hleda ten nejkrasnejsi zensky")
  (printout t crlf)
  (printout t "zadek na svete a vsichni se tvari nepritomne. I ty se zde citis moc dobre, ale zaludek")
  (printout t crlf)
  (printout t "rika, ze by neco jedl.")
  (printout t crlf)
  (printout t "Muzes jit ven z ucebny, tj. na sever.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case s then  (assert (room 2)) ) 
    (case i then  (tu-nic-neni) (assert (room 1)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 1)) )
  )    
)

;; --- Pocitacova ucebna 715 nejzen ----
(defrule room_1_text_2 ""
  (mam plny-brisko)
  (room 1)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Nachazis se v pocitacove ucebne 715, kolem sebe vidis nekolik svych spoluzaku, kteri")
  (printout t crlf)
  (printout t "koukaji do svych obrazovek a nevnimaji deni kolem sebe. Nekdo sledujue novinky na") 
  (printout t crlf)
  (printout t "youtube.com, nekdo zalohuje originalni blueraye, nekdo hleda ten nejkrasnejsi zensky")
  (printout t crlf)
  (printout t "zadek na svete a vsichni se tvari nepritomne.")
  (printout t crlf)
  (printout t "Muzes jit ven z ucebny, tj. na sever.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case s then  (assert (room 2)) ) 
    (case i then  (tu-nic-neni) (assert (room 1)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 1)) )
  )    
)


;; --- Chodba na 7-mem patre ----
(defrule room_2_text ""
  (room 2)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Stojis v dlouhe uzke chodbe, nad tebou huci zarivky a kolem tebe obcas nekdo projde.")
  (printout t crlf)
  (printout t "Pred sebou vidis nastenky, ktere pripominaji doby, kdy se zde vsechno resilo papirove,")
  (printout t crlf)
  (printout t "aktualnost nekterych letaku je toho dukazem. Celkem tu neni nic zajimaveho, krome")  
  (printout t crlf)
  (printout t "dveri do ucebny na jihu a koncu chodby na vychode a zapade.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case j then  (assert (room 1)) ) 
    (case z then  (assert (room 3)) ) 
    (case v then  (assert (room 6)) ) 
    (case i then  (tu-nic-neni) (assert (room 2)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 2)) )
  )    
)

;; --- mistnost u mostu na FEKT ----
(defrule room_6_text ""
  (room 6)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Stojis v neprilis uzivane mistnosti u cerveneho vytahu a spojovacihiho multimostu")
  (printout t crlf)
  (printout t "na druhou budovu. Temnou atmosferu tohoto mista doplnuje smrad valici se z nedalekych")
  (printout t crlf)
  (printout t "hajzliku, ale to te nechava klidnym. Premyslis, co tu vlastne delas. Na vychode vidis") 
  (printout t crlf)  
  (printout t "dvere a na zapade dlouhou uzkou chodbu.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 61)) ) 
    (case z then  (assert (room 2)) ) 
    (case i then  (tu-nic-neni) (assert (room 6)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 6)) )
  )    
)


;; --- u dveri ----
(defrule room_61_text ""
  (room 61)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Srojis u dveri. To je takova deska, ktera zpravidla oddeluje 2 mistnosti od sebe.")
  (printout t crlf)
  (printout t "Klasickym vybavenim dveri je tzv. klika, ktera slouzi k jejich otevreni a zamek,") 
  (printout t crlf)
  (printout t "ktery jejich otevreni znemoznuje. Zkousis dvere otevrit, ale jsou zamcene. Pokud") 
  (printout t crlf)
  (printout t "mas klic, tak urcite otevrit pujdou, ale jinak mas smulu.")  
  (printout t crlf)  
  (printout t "Muzes jit na zapad doprostred mistnosti nebo na vychod do dveri.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 7)) ) 
    (case z then  (assert (room 6)) ) 
    (case i then  (tu-nic-neni) (assert (room 61)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 61)) )
  )    
)


;; --- u dveri bez klice ----
(defrule room_7_text ""
  (room 7)
  (not (mam klice))
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Tak chlape, bez klici to fakt nepujde.. A nekopej do tech dveri :-)")
  (printout t crlf)
  (printout t crlf)
  (assert (room 61))
)

;; --- u dveri s klicem ----
(defrule room_7_text_2 ""
  (room 7)
  (mam klice)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Svazek klicu, ktere jsi nasel v menze ma asi 25 klicu. Jaka se pravedopodovnost.")
  (printout t crlf)
  (printout t "ze se trefis prave tim pravym? Kazdopadne pan Murphy zapracoval a byl to opet")
  (printout t crlf)
  (printout t "ten posledni. Vesel jsi dovnitr, klasicky kubmal uklizecky, tedy spoustu smetaku,") 
  (printout t crlf)
  (printout t "cisticich prostredku, kyblu a jedna zahadna taska, ktera te zaujala. Pomalu jsi ")
  (printout t crlf)
  (printout t "prozkoumal obsah tasky a objevil jsi v ni neco sokujiciho. Byla v ni bomba. Ano,")
  (printout t crlf)
  (printout t "kompletni sestava C4, ovladaci elektroniky a dalkoveho ovladani. Kde se to tu")
  (printout t crlf)
  (printout t "vzalo ti problesklo hlavou? V tom urcite nebude mit uklizecka prsty jsi zacal") 
  (printout t crlf)
  (printout t "spekulovat, to bude vazny.. Premyslis co dal, co mas delat...")
  (printout t crlf)
  (printout t "Muzes bombu vzit a odejit. A nebo odejit bez ni. Dvere jsou na zapad od tebe.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case z then  (assert (room 61)) ) 
    (case i then  (printout t ">>> Vzal sis bombu a odesel z kumbalu. <<<") 
                  (printout t crlf) 
                  (printout t crlf)                   
                  (assert (mam bomb)) 
                  (assert (room 61)) 
    )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 61)) )
  )    
)


;; --- mistnost u pater-nosteru ----
(defrule room_3_text ""
  (room 3)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Pres velka okna vidis panorama Lesne, dole pak velkou cast Kralova Pole. Venku je") 
  (printout t crlf)
  (printout t "hezky, sviti slunicko. Slysis zvuk jedouciho pater-nosteru misici se se zvonenim") 
  (printout t crlf)
  (printout t "mobilu okolojdouciho studenta. Na severu vidis vytah, na zapadne rozbitou zidli,")
  (printout t crlf)
  (printout t "na vychode chodbu.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 2)) ) 
    (case z then  (assert (room 4)) ) 
    (case s then  (assert (room 31)) ) 
    (case i then  (tu-nic-neni) (assert (room 3)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 3)) )
  )    
)


;; --- pred vchodem do UMTB ----
(defrule room_4_text ""
  (room 4)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Krome rozbite zidle jsi zde objevil napis Ustav mechaniky teles. Okamzite")
  (printout t crlf)
  (printout t "se ti rozbusilo srdce a zrudlo pred ocima. Tento ustav mas oblibeny asi") 
  (printout t crlf)
  (printout t "jako pripinacek v zadku :-) Muzes jit na vychod zpet k vytahu a nebo")
  (printout t crlf)
  (printout t "na sever do nitra samotne podstaty vseho zla na tomto svete.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 3)) ) 
    (case s then  (assert (room 5)) ) 
    (case i then  (tu-nic-neni) (assert (room 4)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 4)) )
  )    
)

;; --- uvnitr UMTB bez bomby ----
(defrule room_5_text ""
  (not (mam bomb))
  (room 5)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Vesel jsi dovnitr, mas zrychleny dech a touhu vrazdit kohokoliv na potkani.")
  (printout t crlf)
  (printout t "Tvoje vzpominky na staticke, dynamicke a pruzne problemy jsou stale zive")
  (printout t crlf)
  (printout t "a vyvolavajici nocni mury :-)")
  (printout t crlf)
  (printout t "Muzes pouze odejit a to ti radim.. Mazej honem na jih.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case j then  (assert (room 4)) ) 
    (case i then  (tu-nic-neni) (assert (room 5)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 5)) )
  )    
)

;; --- uvnitr UMTB s bombou ----
(defrule room_5_text_2 ""
  (mam bomb)
  (room 5)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Vesel jsi dovnitr, mas zrychleny dech a touhu vrazdit kohokoliv na potkani.")
  (printout t crlf)
  (printout t "Tvoje vzpominky na staticke, dynamicke a pruzne problemy jsou stale zive")
  (printout t crlf)
  (printout t "a vyvolavajici nocni mury :-)")
  (printout t crlf)
  (printout t "Bombu, kterou mas u sebe, jsi umistil na vhodne misto, zapnul dalkove ovladani.")
  (printout t crlf)
  (printout t "Ted uz staci venku stisknout cervene tlacitko a dilo zkazy bude dokonano...")
  (printout t crlf)
  (printout t "S pocitem praseci radosti muzes odejit na jih :-)")
  (printout t crlf)
  (assert (armed))
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case j then  (assert (room 4)) ) 
    (case i then  (tu-nic-neni) (assert (room 5)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 5)) )
  )    
)

;; --- ve vytahu jedem dolu ----
(defrule room_31_text ""
  (room 31)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Zmacnkul jsi tlacitko na privolani vytahu a ukrutne dlouho jsi cekal nez prijede.")
  (printout t crlf)
  (printout t "Vlezl si do nej, cestou dolu jsi stihl prozkoumat snad vsechny podlazi, protoze")
  (printout t crlf)
  (printout t "nekteri jedinci ani dve patra pesky nezvladnou. Vytah zastavil v prvnim patre")
  (printout t crlf)
  (printout t "a dvere se otevrely. Muzes jit ven, tj. na jih.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case j then  (assert (room 8)) ) 
    (case i then  (tu-nic-neni) (assert (room 31)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 31)) )
  )    
)

;; --- dole u vytahu a kukane vratnyho ----
(defrule room_8_text ""
  (room 8)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Stojis dole u vytahu. V mistnosti panuje docela velky pohyb studaku,")
  (printout t crlf)
  (printout t "kteri se snazi stihnout zacatek sve vyuky. Taky na tebe dost tahne,")
  (printout t crlf)
  (printout t "protoze na jihu se nachazeji dvere z budovy ven. Na zapade vidis vranici,")
  (printout t crlf)
  (printout t "resp. drevenej bobek, co ma pripominat vranici. Na severu je vytah.") 
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case s then  (assert (room 32)) ) 
    (case z then  (assert (room 9)) ) 
    (case j then  (assert (room 13)) ) 
    (case i then  (tu-nic-neni) (assert (room 8)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 8)) )
  )    
)

;; --- pred vedlejsim vchodem ----
(defrule room_13_text ""
  (not (armed) )
  (room 13)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Jses venku pred budovou v raji kuraku. Fakt to dost smrdi.")
  (printout t crlf)
  (printout t "Jedine co zde muzes udelat je skoncit nebo jit zpet do budovy na sever.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case s then  (assert (room 8)) ) 
    (case i then  (tu-nic-neni) (assert (room 13)) )
    (case k then  none ) 
    (default      (assert (room 13)) )
  )    
)

;; --- odpaleni bomby venku  ---
(defrule room_13_text_2 ""
  (armed)
  (room 13)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (assert (room finish))
)

;; --- ve vytahu jedem nahoru ----
(defrule room_32_text ""
  (room 32)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Zmacnkul jsi tlacitko a dvere vytahu se otevrely. To je super, tak to ma fungovat.")
  (printout t crlf)
  (printout t "Vlezl si do nej, kupodivu jsi v nem sam a za par sekund se vytah zastavil a ty jsi")
  (printout t crlf)
  (printout t "uspesne dorazil do 7-meho patra. Muzes jit ven, tj. na jih,")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case j then  (assert (room 3)) ) 
    (case i then  (tu-nic-neni) (assert (room 32)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 32)) )
  )    
)

;; --- u male vratnice ----
(defrule room_9_text ""
  (room 9)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Jsi u vratnice. Nic zajimaveho tu neni. Muzes jit na vychod k vytahu nebo na zapad")
  (printout t crlf)
  (printout t "do siroke chodby u prednaskovych mistnosti.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 8)) ) 
    (case z then  (assert (room 10)) ) 
    (case i then  (tu-nic-neni) (assert (room 9)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 9)) )
  )    
)


;; --- u prednaskovek ----
(defrule room_10_text ""
  (room 10)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Vidis obsazene kresla studaky, kteri usilovne pracuji na nejakych vykresech, uci")
  (printout t crlf)
  (printout t "se zakladny konstruovani a podobne fuj veci, ktere uz mas nastesti davno za sebou.")
  (printout t crlf)
  (printout t "Znacna cast pritomnych kouka do svych notebooku a snazi se zrejme zabit cas. Asi ")
  (printout t crlf)
  (printout t "jeste nepochopili, ze v Kotelne se studuje mnohem lip :-)")
  (printout t crlf)
  (printout t "Muzes jit na vychod k male vratnici nebo na zapad k velke vranici.")
  (printout t crlf)  
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 9)) ) 
    (case z then  (assert (room 11)) ) 
    (case i then  (tu-nic-neni) (assert (room 10)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 10)) )
  )    
)


;; --- u velke vratnice a hlavniho vchodu ----
(defrule room_11_text ""
  (room 11)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Nachazis se u velke vratnice a hlavniho vchodu do arealu. Kolem tebe se") 
  (printout t crlf)
  (printout t "pohybuje neskutecne velke mnozstvi lidi, snazis se uhybat, ale ne vzdy") 
  (printout t crlf)
  (printout t "se ti to podari. Z dalky citis vuni (smard) z jedove chyse..")
  (printout t crlf)
  (printout t "Muzes jit na jih ven z budovy, na vychod do chodby u prednaskovek nebo na") 
  (printout t crlf)
  (printout t "zapad do menzy, ale to jen na vlatni nebezpeci :-)")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case z then  (assert (room 12)) ) 
    (case v then  (assert (room 10)) ) 
    (case j then  (assert (room 14)) ) 
    (case i then  (tu-nic-neni) (assert (room 11)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 11)) )
  )    
)


;; --- pred hlavnim vchodem ----
(defrule room_14_text ""
  (not (armed))
  (room 14)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Jses venku pred budovou. Malem te srazila 53, ale vcas jsi uskocil,")
  (printout t crlf)
  (printout t "takze zijes a to je duvod k radosti :-) Citis smrad z cigaret zavilasku")
  (printout t crlf)
  (printout t "a jedine co zde muzes udelat je skoncit nebo jit zpet do budovy na sever.")
  (printout t crlf)
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case s then  (assert (room 11)) ) 
    (case i then  (tu-nic-neni) (assert (room 14)) )
    (case k then  none ) 
    (default      (assert (room 14)) )
  )    
)

;; --- odpaleni bomby venku  ---
(defrule room_14_text_2 ""
  (armed)
  (room 14)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (assert (room finish))
)

;; --- v menze poprve a bez klicu ----
(defrule room_12_text ""
  (not (mam klice))
  (not (mam plny-brisko))
  (room 12)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Ocitl ses v kralovstvi velkeho pana G :-) Jako vzdy, fronta byla az ven,") 
  (printout t crlf)
  (printout t "pani u vozicku standradne nastvana (asi nedostala premie) a k vyberu vsechny")
  (printout t crlf)
  (printout t "mozne variace na UHO (univerzalni hneda omacka). Vzal sis nejaky testoviny,")
  (printout t crlf)
  (printout t "nasel volne misto a zacal jist. Na zemi vidis svazek klicu, ktere ocividne ")
  (printout t crlf)
  (printout t "nikomu nepatri. Po dojezeni, paklize to prezijes, muzes jit na vychod.")
  (printout t crlf)
  (assert (mam plny-brisko))
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 11)) ) 
    (case i then  (printout t ">>> Vzal sis klice a odesel z menzy. <<<") 
                  (printout t crlf) 
                  (printout t crlf)                   
                  (assert (mam klice)) 
                  (assert (room 11)) 
    )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 12)) )
  )    
)

;; --- v menze ponekolikate a bez klicu ----
(defrule room_12_text_2 ""
  (not (mam klice))
  (mam plny-brisko)
  (room 12)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Ty mas zase hlad? I to se muze v menze stat, tak si dej trebas smazak, ") 
  (printout t crlf)
  (printout t "protoze po nem te opravdu prejde chut na cokoliv jinyho :-)")
  (printout t crlf)
  (printout t "Na zemi stale vidis svazek klicu, ktere ocividne nikomu nepatri.")
  (printout t crlf)
  (printout t "Muzes jit na vychod.")
  (printout t crlf)
  (assert (mam plny-brisko))
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 11)) ) 
    (case i then  (printout t ">>> Vzal sis klice a odesel z menzy. <<<") 
                  (printout t crlf) 
                  (printout t crlf)                   
                  (assert (mam klice)) 
                  (assert (room 11)) 
    )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 12)) )
  )    
)

;; --- v menze ponekolikate s kliecema ----
(defrule room_12_text_3 ""
  (mam klice)
  (mam plny-brisko)
  (room 12)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Ty mas zase hlad? I to se muze v menze stat, tak si dej trebas smazak, ") 
  (printout t crlf)
  (printout t "protoze po nem te opravdu prejde chut na cokoliv jinyho :-)")
  (printout t crlf)
  (printout t "Muzes jit na vychod.")
  (printout t crlf)
  (assert (mam plny-brisko))
  (bind ?cmd (show-get-commands))
  (switch ?cmd
    (case v then  (assert (room 11)) ) 
    (case i then  (tu-nic-neni) (assert (room 12)) )
    (case k then  none ) 
    (default      (drzkoryje)   (assert (room 12)) )
  )    
)

;; --- epilog ----
(defrule room_finish_text ""
  (room finish)
  ?fact <- (room ?)
   =>
  (retract ?fact)
  (printout t "Vysel jsi ven pred budovu, v ruce drzis ovladac dalkoveho ovladani.")
  (printout t crlf)
  (printout t "Mackas, ozyva se ohlusujici rana a pak jen ...")
  (printout t crlf)
  (printout t "Znate jak to konci, zamrizovany anton a uz te vedou aleji opadanych hrusni ")
  (printout t crlf)
  (printout t "k pankrackemu kopecku...")
  (printout t crlf)  
  (printout t "Dohra je kratka, jak tomu byva u podobnych pribehu, soud byl nestrany, ")
  (printout t crlf)  
  (printout t "tvrdy, drsny a spravedlivy, a tak jednoho rana nez kohout zakokrhal") 
  (printout t crlf)  
  (printout t "prisla koorta mongoloidu a vyvedla te po cerstve ohoblovanych dobovch ")
  (printout t crlf)  
  (printout t "fosnach tam, kde je to temne propadlo s konopnym lasem. Skrze strepy ")
  (printout t crlf)  
  (printout t "nasypane na zdi okolo pankrackeho vezeni videl jsi mihotat a trpitit") 
  (printout t crlf)  
  (printout t "se slunecko, ktere vychazelo v jasnych cervankach. ")
  (printout t crlf crlf)
  (printout t "Byl to jen sen? Mozna ano, mozna ne .... ")
  (printout t crlf crlf)
 
)



